import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Solution to You Be The Judge, Again
 * 
 * @author vanb
 */
public class ybtj2_vanb
{
    /** Input. */
    private static Scanner sc;
    
    /** Output. */
    private static PrintStream ps;
    
    /**
     * Do it!
     */
    private void doit()
    {
        int n = sc.nextInt();
        int m = 1<<n;
        int k = (1<<(n+n))/3;
        
        int counts[] = new int[k+1];
        Arrays.fill(  counts, 0 );
        boolean success = true;
        int tiling[][] = new int[m][m];
        
        // Read in the data, make sure there's exactly one 0 and three of everything else.
        // If there's less than three of something, there'll be more than three of something else.
        for( int i=0; i<m; i++ ) for( int j=0; j<m; j++ ) 
        {
            int x = sc.nextInt();
            tiling[i][j] = x;
            ++counts[x];
            if( counts[x] > (x==0 ? 1 : 3) ) success = false;
        }
        
        if( success )
        {
            // Now test that the three cells of each tile form an L shape.
            // there should be exactly one center, with one cell (up or down), and one cell (left or right)
            for( int i=0; i<m; i++ ) for( int j=0; j<m; j++ ) 
            {
                int sum = 0;
                int x = tiling[i][j];
                
                // Up/Down
                if( i>0 && tiling[i-1][j]==x ) sum += 1;
                if( i<m-1 && tiling[i+1][j]==x ) sum += 1;
                
                // Left/Right
                if( j>0 && tiling[i][j-1]==x ) sum += 2;
                if( j<m-1 && tiling[i][j+1]==x ) sum += 2;
                
                // No way to get three unless there's exactly one up/down and exactly one left/right.
                // Since we've already determined that there's exactly 3 of each positive number,
                // this can't happen more than once per triomino.
                if( sum==3 ) --k;
            }
            
            // Make sure we got 'k' triominos
            if( k>0 ) success = false;
        }
        
        ps.println( success ? 1 : 0 );
    }
        
    /**
     * Main.
     * 
     * @param args unused
     * @throws Exception
     */
    public static void main( String[] args ) throws Exception
    {
        sc = new Scanner( System.in );
        ps = System.out;
        
        new ybtj2_vanb().doit();
    }

}
